Module Test
  Public Sub Visualizar(ByVal car As Byte)
    Dim i, bit As Integer
    For i = 7 To 0 Step -1
      If ((car And (1 * (2 ^ i))) <> 0) Then
        bit = 1
      Else
        bit = 0
      End If
      System.Console.Write(bit)
    Next
    System.Console.WriteLine()
  End Sub

  Public Function HaceAlgo(ByVal car As Byte) As Byte
    Return ((car And &H1) * (2 ^ 7)) Or ((car And &H2) * (2 ^ 5)) Or _
           ((car And &H4) * (2 ^ 3)) Or ((car And &H8) * (2 ^ 1)) Or _
           ((car And &H10) \ (2 ^ 1)) Or ((car And &H20) \ (2 ^ 3)) Or _
           ((car And &H40) \ (2 ^ 5)) Or ((car And &H80) \ (2 ^ 7))
  End Function

  Public Sub Main()
    Dim car As Byte

    System.Console.Write("Introduce un carácter Unicode: ")
    car = System.Console.Read()
    Visualizar(car)
    System.Console.WriteLine("Carácter resultante:")
    car = HaceAlgo(car)
    Visualizar(car)
  End Sub
End Module

' Este programa:
' 1.- Solicita un byte (carácter entre 0 y 255) de la entrada estándar.
' 2.- Invoca a Visualizar para mostrar el valor en binario del carácter.
' 3.- Invoca a HaceAlgo para obtener el valor reflejado de ese carácter.
' 4.- Invoca a Visualizar para mostrar el byte reflejado.
' Por ejemplo:
'   Introduce un carácter Unicode: a
'   01100001
'   Carácter resultante:
'   10000110
'
' Ayuda:
' Supongamos el valor de car = 00001000 en binario (8 en decimal)
' car * (2^i) desplaza los bits de car i posiciones hacia la izquierda
' introduciendo ceros por la derecha.
'
' car \ (2^i) desplaza los bits de car i posiciones hacia la derecha
' introduciendo el bit de signo por la izquierda.
'
' Songamos el valor de car = 01100001:
'   01100001 And 10000000 = 00000000 (valor 0)
'   01100001 And 01000000 = 01000000 (valor distinto de 0)
