﻿Imports System
Imports System.IO
Imports System.Environment
Imports MisClases.ES ' espacio de nombres de la clase Leer

' Aplicación para trabajar con un fichero accedido aleatoriamente
'
Module Test
  Dim listatfnos As CListaTfnos

  Public Function modificar(nreg As Integer) As Boolean
    Dim nombre, dirección As String
    Dim teléfono As Long
    Dim op As Integer
    ' Leer el registro
    Dim obj As CPersona = listatfnos.leerReg(nreg)
    If (obj Is Nothing) Then Return False

    ' Modificar el registro
    Do
      Console.WriteLine(NewLine)
      Console.WriteLine("Modificar el dato:")
      Console.WriteLine("1. Nombre")
      Console.WriteLine("2. Dirección")
      Console.WriteLine("3. Teléfono")
      Console.WriteLine("4. Salir y salvar los cambios")
      Console.WriteLine("5. Salir sin salvar los cambios")
      Console.WriteLine()
      Console.Write("   Opción: ")
      op = Leer.datoInt()

      Select Case (op)
        Case 1 ' modificar nombre
          Console.Write("nombre:    ")
          nombre = Console.ReadLine()
          obj.asignarNombre(nombre)
        Case 2 ' modificar dirección
          Console.Write("dirección: ")
          dirección = Console.ReadLine()
          obj.asignarDirección(dirección)
        Case 3 ' modificar teléfono
          Console.Write("teléfono:  ")
          teléfono = Leer.datoLong()
          obj.asignarTeléfono(teléfono)
        Case 4 ' guardar los cambios
          ' Operación pospuesta a la salida del switch
          listatfnos.escribirReg(nreg, obj)
          Return True
        Case 5 ' salir sin guardar los cambios
      End Select
    Loop While (op <> 5)

    Return False
  End Function

  Public Sub actualizar(fActual As String)
    ' Crear un fichero temporal
    Dim ficheroTemp As String = "listatfnos.tmp"
    Dim ftemp As CListaTfnos = New CListaTfnos(ficheroTemp)
    Dim nregs As Integer = listatfnos.númeroDeRegs()
    ' Copiar en el fichero temporal todos los registros del
    ' fichero actual que en su campo teléfono no tengan un 0
    Dim obj As CPersona
    Dim reg_i As Integer
    For reg_i = 0 To nregs - 1
      obj = listatfnos.leerReg(reg_i)
      If (obj.obtenerTeléfono() <> 0) Then
        ftemp.añadirReg(obj)
      End If
    Next
    listatfnos.cerrarFichero()
    ftemp.cerrarFichero()
    File.Copy(ficheroTemp, fActual, True)
    File.Delete(ficheroTemp)
  End Sub

  Public Function menú() As Integer
    Console.WriteLine()
    Console.WriteLine("1. Buscar")
    Console.WriteLine("2. Buscar siguiente")
    Console.WriteLine("3. Modificar")
    Console.WriteLine("4. Añadir")
    Console.WriteLine("5. Eliminar")
    Console.WriteLine("6. Imprimir")
    Console.WriteLine("7. Salir")
    Console.Write("   Opción: ")
    Dim op As Integer
    Do
      op = Leer.datoInt()
    Loop While (op < 1 Or op > 7)
    Console.WriteLine()
    Return op
  End Function

  Public Sub imprimirListaTfnos()
    ' Almacenar lo que se va a imprimir en un fichero temporal
    Dim flujoS As StreamWriter = New StreamWriter("temp")
    ' Número de registros
    Dim nregs As Integer = listatfnos.númeroDeRegs()
    Dim obj As CPersona
    Dim n As Integer
    For n = 0 To nregs - 1
      ' Imprimir el registro n de la lista de teléfonos
      flujoS.WriteLine("Registro: " & n)
      obj = listatfnos.leerReg(n)
      flujoS.WriteLine(obj.obtenerNombre())
      flujoS.WriteLine(obj.obtenerDirección())
      flujoS.WriteLine(obj.obtenerTeléfono())
      flujoS.WriteLine() ' saltar una línea
    Next
    flujoS.Close()   ' cerrar el flujo hacia la impresora

    Dim impre As ImprimirFichero = New ImprimirFichero
    impre.ImprimirDocumento("temp")
    File.Delete("temp")
  End Sub

  Public Sub Main(ByVal args() As String)
    Dim opción As Integer = 0, pos As Integer = -1
    Dim cadenabuscar As String = Nothing
    Dim nombre, dirección As String
    Dim teléfono As Long
    Dim eliminado As Boolean = False
    Dim modificado As Boolean = False
    Dim obj As CPersona

    Try
      ' Crear un objeto lista de teléfonos vacío (con 0 elementos)
      ' o con el contenido del fichero listatfnos.dat si existe.
      Dim fichero As String = "listatfnos.dat"
      listatfnos = New CListaTfnos(fichero)

      Do
        opción = menú()
        Select Case (opción)
          Case 1 ' buscar
            Console.Write("conjunto de caracteres a buscar ")
            cadenabuscar = Console.ReadLine()
            pos = listatfnos.buscarReg(cadenabuscar, 0)
            If (pos = -1) Then
              If (listatfnos.númeroDeRegs() <> 0) Then
                Console.WriteLine("búsqueda fallida")
              Else
                Console.WriteLine("lista vacía")
              End If
            Else
              obj = listatfnos.leerReg(pos)
              Console.WriteLine("Número de registro: " & pos)
              Console.WriteLine(obj.obtenerNombre())
              Console.WriteLine(obj.obtenerDirección())
              Console.WriteLine(obj.obtenerTeléfono())
            End If
          Case 2 ' buscar siguiente
            pos = listatfnos.buscarReg(cadenabuscar, pos + 1)
            If (pos = -1) Then
              If (listatfnos.númeroDeRegs() <> 0) Then
                Console.WriteLine("búsqueda fallida")
              Else
                Console.WriteLine("lista vacía")
              End If
            Else
              obj = listatfnos.leerReg(pos)
              Console.WriteLine("Número de registro: " & pos)
              Console.WriteLine(obj.obtenerNombre())
              Console.WriteLine(obj.obtenerDirección())
              Console.WriteLine(obj.obtenerTeléfono())
            End If
          Case 3 ' modificar
            ' Solicitar el número de registro a modificar  
            Console.Write("número de registro entre 0 y " & _
                          (listatfnos.númeroDeRegs() - 1) & ": ")
            pos = Leer.datoInt()
            modificado = modificar(pos)
            If (modificado) Then
              Console.WriteLine("modificación realizada con éxito")
            Else
              Console.WriteLine("error: no se modificó el registro")
            End If
          Case 4 ' añadir
            Console.Write("nombre:    ") : nombre = Console.ReadLine()
            Console.Write("dirección: ") : dirección = Console.ReadLine()
            Console.Write("teléfono:  ") : teléfono = Leer.datoLong()
            listatfnos.añadirReg(New CPersona(nombre, dirección, teléfono))
          Case 5 ' eliminar
            Console.Write("teléfono: ") : teléfono = Leer.datoLong()
            eliminado = listatfnos.eliminarReg(teléfono)
            If (eliminado) Then
              Console.WriteLine("registro eliminado")
            Else
              If (listatfnos.númeroDeRegs() <> 0) Then
                Console.WriteLine("teléfono no encontrado")
              Else
                Console.WriteLine("lista vacía")
              End If
            End If
          Case 6 ' imprimir
            imprimirListaTfnos()
          Case 7 ' salir
            ' guardar lista
            If (listatfnos.tieneRegsEliminados()) Then
              actualizar(fichero)
              listatfnos = Nothing
            End If
        End Select
      Loop While (opción <> 7)
    Catch e As IOException
      Console.WriteLine("Error: " & e.Message)
    End Try
  End Sub
End Module
