﻿Imports System
Imports System.IO
Imports MisClases.ES ' espacio de nombres de la clase Leer

' Aplicación para trabajar con un fichero accedido aleatoriamente
' Utiliza la clase Leer para leer de la entrada estándar cadenas
' y datos de tipos primitivos.
Module Test
  Dim artículos As CBaseDeDatos
  Dim ficheroAbierto As Boolean

  Public Sub nuevoFich()
    If (ficheroAbierto) Then
      Console.WriteLine("Ya hay un fichero abierto.")
      Return
    End If
    Console.Write("Nombre del fichero: ")
    Dim strFichero As String = Console.ReadLine() ' nombre del fichero
    While (File.Exists(strFichero))
      Console.WriteLine("Este fichero existe. Escriba otro.")
      strFichero = Console.ReadLine()
    End While
    If (strFichero.Length = 0) Then Return
    artículos = New CBaseDeDatos(strFichero)
    ficheroAbierto = True
  End Sub

  Public Sub abrirFich()
    If (ficheroAbierto) Then
      Console.WriteLine("Ya hay un fichero abierto.")
      Return
    End If

    Console.Write("Nombre del fichero: ")
    Dim strFichero As String = Console.ReadLine() ' nombre del fichero

    Dim fichero() As String
    Dim resp As Char
    While (Not File.Exists(strFichero))
      Console.WriteLine("Este fichero no existe.")
      Console.Write("Desea ver la lista de ficheros? s/n: ")
      resp = Convert.ToChar(Console.Read())
      Console.ReadLine() ' limpiar el buffer de entrada
      If (resp = "n"c) Then Return
      ' Obtener un listado del directorio actual de trabajo
      fichero = Directory.GetFiles(Directory.GetCurrentDirectory())
      Dim i As Integer
      For i = 0 To fichero.Length - 1
        Console.Write(Path.GetFileName(fichero(i)) + ",  ")
      Next
      Console.WriteLine()
      Console.Write("Nombre del fichero: ")
      strFichero = Console.ReadLine()
    End While
    artículos = New CBaseDeDatos(strFichero)
    ficheroAbierto = True
  End Sub

  Public Sub añadirReg()
    Dim referencia As String
    Dim precio As Double

    Console.Write("Referencia:    ")
    referencia = Console.ReadLine()
    Console.Write("Precio:        ")
    precio = Leer.datoDouble()
    artículos.añadir(New CRegistro(referencia, precio))
  End Sub

  Public Sub modificarReg()
    Dim referencia As String
    Dim precio As Double
    Dim op, nreg As Integer

    ' Solicitar el número de registro a modificar
    Console.Write("Número de registro entre 0 y " & _
                  (artículos.longitud() - 1) & ": ")
    nreg = Leer.datoInt()

    ' Leer el registro
    Dim obj As CRegistro = artículos.valorEn(nreg)
    If (obj Is Nothing) Then Return
    ' Visualizarlo
    Console.WriteLine(obj.obtenerReferencia())
    Console.WriteLine(obj.obtenerPrecio())

    ' Modificar el registro
    Do
      Console.WriteLine()
      Console.WriteLine("Modificar el dato:")
      Console.WriteLine("1. Referencia")
      Console.WriteLine("2. Precio")
      Console.WriteLine("3. Salir y salvar los cambios")
      Console.WriteLine("4. Salir sin salvar los cambios")
      Console.WriteLine()
      Console.Write("   Opción: ")
      op = Leer.datoInt()

      Select Case (op)
        Case 1 ' modificar referencia
          Console.Write("Referencia:    ")
          referencia = Console.ReadLine()
          obj.asignarReferencia(referencia)
        Case 2 ' modificar precio
          Console.Write("Precio:  ")
          precio = Leer.datoDouble()
          obj.asignarPrecio(precio)
        Case 3 ' guardar los cambios
          artículos.ponerValorEn(nreg, obj)
          Return
        Case 4 ' salir sin guardar los cambios
      End Select
    Loop While (op <> 4)
  End Sub

  Public Function eliminarReg() As Boolean
    Dim referencia As String
    Console.Write("Referencia: ")
    referencia = Console.ReadLine()
    Dim eliminado As Boolean = artículos.eliminar(referencia)
    If (eliminado) Then
      Console.WriteLine("registro eliminado")
    Else
      If (artículos.longitud() <> 0) Then
        Console.WriteLine("referencia no encontrada")
      Else
        Console.WriteLine("lista vacía")
      End If
    End If
    Return eliminado
  End Function

  Public Sub visualizarRegs()
    Dim nreg As Integer = -1, nregs As Integer = artículos.longitud()
    If (nregs = 0) Then
      Console.WriteLine("lista vacía")
    End If
    Console.Write("conjunto de caracteres a buscar: ")
    Dim str As String = Console.ReadLine()
    Dim obj As CRegistro
    Do
      nreg = artículos.buscar(str, nreg + 1)
      If (nreg > -1) Then
        obj = artículos.valorEn(nreg)
        Console.WriteLine("Registro: " & nreg)
        Console.WriteLine(obj.obtenerReferencia())
        Console.WriteLine(obj.obtenerPrecio())
        Console.WriteLine()
      End If
    Loop While (nreg <> -1)
    If (obj Is Nothing) Then
      Console.WriteLine("no se encontró ningún registro")
    End If
  End Sub

  Public Function menú() As Integer
    Console.WriteLine()
    Console.WriteLine("1. Nuevo fichero")
    Console.WriteLine("2. Abrir fichero")
    Console.WriteLine("3. Añadir registro")
    Console.WriteLine("4. Modificar registro")
    Console.WriteLine("5. Eliminar registro")
    Console.WriteLine("6. Visualizar registros")
    Console.WriteLine("7. Salir")
    Console.WriteLine()
    Console.Write("   Opción: ")
    Dim op As Integer
    Do
      op = Leer.datoInt()
      If (op < 1 Or op > 7) Then
        Console.Write("Opción no válida. Elija otra: ")
      End If
    Loop While (op < 1 Or op > 7)
    Console.WriteLine()
    If (op > 2 And op < 7 And Not ficheroAbierto) Then
      Console.WriteLine("No hay un fichero abierto.")
      Return 0
    End If
    Return op
  End Function

  Public Sub Main(args() As String)
    Dim opción As Integer

    Try
      Do
        opción = menú()
        Select Case (opción)
          Case 1 ' nuevo fichero
            nuevoFich()
          Case 2 ' abrir fichero
            abrirFich()
          Case 3 ' añadir registro al final del fichero
            añadirReg()
          Case 4 ' modificar registro
            modificarReg()
          Case 5 ' eliminar registro
            eliminarReg()
          Case 6 ' visualizar registros
            visualizarRegs()
          Case 7 ' salir
            If (Not (artículos Is Nothing) AndAlso _
                artículos.tieneRegsEliminados()) Then
              artículos.actualizar()
            End If
            artículos = Nothing
        End Select
      Loop While (opción <> 7)
    Catch e As IOException
      Console.WriteLine("Error: " + e.Message)
    End Try
  End Sub
End Module
